/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.image.*;
import java.awt.event.*;

class Anzeige extends Canvas implements MouseListener {
	public Anzeige () {
		super();
		setSize (1000,200);

		anzeige = Tools.loadImage ("anzeige");

		initLampen();
		
		addMouseListener(this);
	}
	
	public void initBlock (Block l, Block r) {
		bf = new Bahnhof[2];
		bf[0] = new Bahnhof(l);
		bf[1] = new Bahnhof(r);
	}
	
	public void initLampen () {
		l = new Lampe[30];
		l[0]  = new Lampe (this, 290, 110, Color.YELLOW);	// Weiche 1
		l[1]  = new Lampe (this, 330, 110, Color.YELLOW);	// Weiche 2
		l[2]  = new Lampe (this, 590, 110, Color.YELLOW);	// Weiche 4
		l[3]  = new Lampe (this, 690, 110, Color.YELLOW);	// Weiche 5
		l[4]  = new Lampe (this, 250, 110, Color.YELLOW);	// Uebergang 1
		l[5]  = new Lampe (this, 330, 150, Color.YELLOW);	// Gleis bei Weiche 1
		l[6]  = new Lampe (this, 650, 110, Color.YELLOW);	// Gleis zwischen Weiche 4 und 5
		l[7]  = new Lampe (this, 650, 150, Color.YELLOW);	// Gleis bei Weiche 5
		
		l[8]  = new Lampe (this, 150,  70, Color.RED);		// Signal A
		l[9]  = new Lampe (this, 170,  70, Color.GREEN);
		l[10] = new Lampe (this, 130,  70, Color.ORANGE);
		
		l[11] = new Lampe (this, 230, 150, Color.RED);		// Signal B
		l[12] = new Lampe (this, 210, 150, Color.GREEN);
		l[13] = new Lampe (this, 250, 150, Color.ORANGE);
		
		l[14] = new Lampe (this, 770,  70, Color.RED);		// Signal C
		l[15] = new Lampe (this, 790,  70, Color.GREEN);
		l[16] = new Lampe (this, 750,  70, Color.ORANGE);
		
		l[17] = new Lampe (this, 850, 150, Color.RED);		// Signal D
		l[18] = new Lampe (this, 830, 150, Color.GREEN);
		l[19] = new Lampe (this, 870, 150, Color.ORANGE);
		
		l[20] = new Lampe (this,  30,  70, Color.YELLOW);	// Signal A*
		l[21] = new Lampe (this, 970, 150, Color.YELLOW);	// Signal B*
		
		l[22] = new Blocklampe (this,  30, 110, Color.RED, Blocklampe.RECHTS);
		l[23] = new Blocklampe (this,  50, 110, Color.YELLOW, Blocklampe.RECHTS);
		l[24] = new Blocklampe (this,  90, 110, Color.RED, Blocklampe.LINKS);
		l[25] = new Blocklampe (this,  70, 110, Color.YELLOW, Blocklampe.LINKS);
		
		l[26] = new Blocklampe (this, 970, 110, Color.RED, Blocklampe.LINKS);
		l[27] = new Blocklampe (this, 950, 110, Color.YELLOW, Blocklampe.LINKS);
		l[28] = new Blocklampe (this, 910, 110, Color.RED, Blocklampe.RECHTS);
		l[29] = new Blocklampe (this, 930, 110, Color.YELLOW, Blocklampe.RECHTS);
		
		sig = new Signal[4];
		sig[0] = new Signal (l[8], l[9], l[10]);
		sig[1] = new Signal (l[11], l[12], l[13]);
		sig[2] = new Signal (l[14], l[15], l[16]);
		sig[3] = new Signal (l[17], l[18], l[19]);
		
	}
	
	public void paint (Graphics g) {
		int i;
		g.drawImage (anzeige, 0, 0, this);
		for (i = 0; i < 30; i++) l[i].paint(g);
	}
	
	public void repaintLampen () {
//		repaint();
		int i;
		Graphics g = getGraphics();
		for (i = 0; i < 30; i++) l[i].paint(g);
	}
	
	public Lampe l[];
	public Signal sig[];
	
	BufferedImage anzeige;
	
	Bahnhof bf[];
	
	public void mouseClicked (MouseEvent e) {
		int x;
		if (e.getY() > 20) return;
		
		x = e.getX();
		
		if (x < 80) {
			x *= 5;
			bf[0].sendeZug(x);
		} else if (x > 920) {
			x = (1000-x) * 5;
			bf[1].sendeZug(x);
		}
	}
	
	public void mousePressed (MouseEvent e) { }
	public void mouseReleased (MouseEvent e) { }
	public void mouseEntered (MouseEvent e) { }
	public void mouseExited (MouseEvent e) { }
	
	static final long serialVersionUID = 8212942283898080863L;
}
