/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

import java.awt.*;
import java.awt.image.*;

class FSHebel {
	static {
		hebel = Tools.loadImage ("fs_hebel");
	}

	public FSHebel (FSKasten p, int x, int y, String platte_name, Fahrstrasse fo, Fahrstrasse fu) {
//		if (hebel == null) hebel = Tools.loadImage ("fs_hebel");
		platte = Tools.loadImage (platte_name);
		
		pos = new Point(x, y);
		parent = p;
		fs_oben = fo;
		fs_unten = fu;
	}
	
	public boolean hebelOben() {
		if (stellung == -1) return false;
		if (stellung == 1)
			if (!fs_unten.fsAufloesen()) return false;
		stellung = 0;
		if (!fs_oben.fsEinstellen()) return false;
		stellung = -1;
		return true;
	}
	
	public boolean hebelMitte() {
		if (stellung == 0) return false;
		if (stellung == -1)
			if (!fs_oben.fsAufloesen()) return false;
		if (stellung == 1)
			if (!fs_unten.fsAufloesen()) return false;
		stellung = 0;
		return true;
	}
	
	public boolean hebelUnten() {
		if (stellung == 1) return false;
		if (stellung == -1)
			if (!fs_oben.fsAufloesen()) return false;
		stellung = 0;
		if (!fs_unten.fsEinstellen()) return false;
		stellung = 1;
		return true;
	}
		
	public void paint(Graphics g) {
		g.drawImage (platte, pos.x, pos.y, parent);
		if (stellung == -1) g.drawImage (hebel, pos.x + 25, pos.y + 3, parent);
		if (stellung == 0) g.drawImage (hebel, pos.x + 25, pos.y + 38, parent);
		if (stellung == 1) g.drawImage (hebel, pos.x + 25, pos.y + 71, parent);
	}
	
	Point pos;
	int stellung;
	static BufferedImage hebel;
	BufferedImage platte;
	FSKasten parent;
	
	Fahrstrasse fs_oben;
	Fahrstrasse fs_unten;
}

