/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

/**
 * @author Simon Gander
 */

public class FSWeiche extends Weiche {
	public FSWeiche (int nr) {
		super(nr);
	}
	
	public void initSignale (Signalhebelsperre e, Signalhebelsperre a) {
		ske = e;
		ska = a;
	}
	
	public void belegen (boolean richtung) {
		super.belegen(richtung);
		war_belegt = true;
		ske.signalHalt();
		ska.blocken();
	}
	
	public void freigeben (boolean richtung) {
		super.freigeben(richtung);
		belegt = false;
		if (war_belegt) {
			ske.betriebsAufloesung();
			ska.signalHalt();
			ska.betriebsAufloesung();
		}
		ske.zugEingefahren();
		war_belegt = false;
	}
	
	Signalhebelsperre ske;
	Signalhebelsperre ska;
	boolean war_belegt;
}
