/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

class Fahrstrasse {
	public Fahrstrasse (int id) {
		nr = id;
	}
	
	public static void initialisieren () {
		int i;
		wh = new Weichenhebel[4];
		sh = new Signalhebel[6];
		fs = new Fahrstrasse[12];
		for (i = 0; i < 12; i++) {
			fs[i] = new Fahrstrasse(i);
		}
	}
	
	public boolean fsSperren (boolean ausfuehren) {
		if (eingestellt) return false;
		if (!ausfuehren) return true;
		gesperrt++;
		return true;
	}
	
	public void fsFreigeben () {
		if (gesperrt <= 0) System.out.println ("Fahrstrassenfreigabe: Nicht gesperrt");
		gesperrt--;
	}
	
	public boolean fsEinstellen () {
		int i;
		
		if (fs_tab[nr][22] != 0) {
			if (!FSKasten.gl_anz[fs_tab[nr][22] - 1].einfahrtOk()) return false;
		}
		
		for (i = 0; i <= 3; i++) {
			switch (fs_tab[nr][i]) {
			case 1:
				if (!wh[i].weicheVerschliessen(false, false)) return false;
				break;
			case 2:
				if (!wh[i].weicheVerschliessen(true, false)) return false;
				break;
			}
		}
		for (i = 0; i <= 11; i++) {
			switch (fs_tab[nr][i+10]) {
			case 1:
				if (!fs[i].fsSperren(false)) return false;
			}
		}
		for (i = 0; i <= 3; i++) {
			switch (fs_tab[nr][i]) {
			case 1:
				if (!wh[i].weicheVerschliessen(false, true)) return false;
				break;
			case 2:
				if (!wh[i].weicheVerschliessen(true, true)) return false;
				break;
			}
		}
		for (i = 0; i <= 11; i++) {
			switch (fs_tab[nr][i+10]) {
			case 1:
				if (!fs[i].fsSperren(true)) return false;
			}
		}
		for (i = 0; i <= 5; i++) {
			switch (fs_tab[nr][i+4]) {
			case 1:
				sh[i].signalFreigeben (1);
				break;
			case 2:
				sh[i].signalFreigeben (2);
				break;
			case 3:
				// Braucht es gar nicht...
			}
		}
		eingestellt = true;
//		FSKasten.gl_anz[fs_tab[nr][22]].einschalten();
		if (fs_tab[nr][22] != 0) {
			FSKasten.gl_anz[fs_tab[nr][22]-1].einfahrtStellen();
		}
		if (fs_tab[nr][23] != 0) {
			FSKasten.gl_anz[fs_tab[nr][23]-1].ausfahrtStellen();
		}
		return true;
	}
	
	public boolean fsAufloesen () {
		int i;

		if (fs_tab[nr][23] != 0) {
			if (!FSKasten.gl_anz[fs_tab[nr][23] - 1].ausfahrtAufloesenOk()) return false;
		}

		for (i = 0; i <= 5; i++) {
			if (fs_tab[nr][i+4] != 0) 
				if (!sh[i].signalSperren()) return false;
		}
		for (i = 0; i <= 3; i++) {
			if (fs_tab[nr][i] != 0)
				wh[i].weicheFreigeben();
		}
		for (i = 0; i <= 11; i++) {
			if (fs_tab[nr][i+10] != 0)
				fs[i].fsFreigeben();
		}
		eingestellt = false;
//		FSKasten.gl_anz[fs_tab[nr][22]].ausschalten();
		if (fs_tab[nr][22] != 0) {
			FSKasten.gl_anz[fs_tab[nr][22]-1].einfahrtAufloesen();
		}
		if (fs_tab[nr][23] != 0) {
			FSKasten.gl_anz[fs_tab[nr][23]-1].ausfahrtAufloesen();
		}
		return true;
	}

	// bool weicheVerschliessen (plus/minus)
	// void weicheOeffnen ()
	// void signalFreigeben (fahrt/fahrt2)
	// bool signalSperren ()		-> Geht nur wenn Signal auf Halt.
	// bool signalFesthalten ()	(Von Durchfahrtsignalen)
	// bool fsSperren ()
	// bool fsFreigeben ()
	
	public static int fs_tab[][] = {
	//	  1  2 34  5  A Ad  B  C Dd  D a2 a3 a1 b1 b2 b3 c2 c3 c1 d1 d2 d3  E  A
		{ 1, 1, 1, 1, 1, 3, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 2, 0},	// a2
		{ 2, 0, 0, 2, 2, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 3, 0},	// a3
		{ 1, 2, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 1, 0},	// a1
		{ 1, 2, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1},	// b1
		{ 1, 1, 1, 0, 0, 0, 1, 0, 3, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 2},	// b2
		{ 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 3},	// b3
		{ 0, 0, 1, 1, 0, 3, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 2},	// c2
		{ 0, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 3},	// c3
		{ 0, 0, 2, 1, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 1},	// c1
		{ 0, 0, 2, 1, 0, 0, 0, 0, 0, 2, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0},	// d1
		{ 1, 1, 1, 1, 0, 0, 0, 0, 3, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 2, 0},	// d2
		{ 2, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 3, 0}	// d3
	};
	
	int nr;
	public static Signalhebel[] sh;
	public static Weichenhebel[] wh;
	public static Fahrstrasse[] fs;
	boolean eingestellt;
	int gesperrt;
}
