/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

import java.awt.*;

class Hauptfenster extends Container {
	public Hauptfenster () {
		super();
		setLayout (new BorderLayout(0, 0));
		setBackground (Color.BLACK);
		initialisieren ();
	}
	
	public void initialisieren () {
		anz = new Anzeige ();
		add(anz, BorderLayout.NORTH);
//		setSize (1000, 700);
		anz.l[8].einschalten();
		anz.l[11].einschalten();
		anz.l[14].einschalten();
		anz.l[17].einschalten();
		anz.l[23].einschalten();
		anz.l[27].einschalten();
		
//		anz.repaint();
		hebelage = new Container ();
//		hebelage.setSize (600, 500);
		hebelage.setLayout (new BorderLayout(0, 0));
		add (hebelage, BorderLayout.WEST);
		
		hebelkaesten = new Container ();
//		hebelkaesten.setSize (600, 80);
		hebelage.add (hebelkaesten, BorderLayout.NORTH);
		
		hebelbank = new Container ();
//		hebelbank.setSize (600, 420);
		hebelage.add (hebelbank, BorderLayout.SOUTH);
		
		hebelbank.setLayout (new GridLayout (1, 10));
		hebelkaesten.setLayout (new GridLayout (1, 10));
		
		Fahrstrasse.initialisieren();

		fs_kasten = new FSKasten ();
		fs_kasten.setSize (400,500);
		add (fs_kasten, BorderLayout.EAST);
		
		kasten = new Hebelsperre[10];
//		Kasten.initialisieren();
		kasten[0] = new Weichenhebelsperre ();
		kasten[1] = new Weichenhebelsperre ();
		kasten[2] = new Signalhebelsperre (false, fs_kasten.bk[0], anz.sig[0]);
		kasten[3] = new DSigPseudosperre ();
		kasten[4] = new Signalhebelsperre (true, fs_kasten.bk[0], anz.sig[1]);
		kasten[5] = new Signalhebelsperre (true, fs_kasten.bk[1], anz.sig[2]);
		kasten[6] = new DSigPseudosperre ();
		kasten[7] = new Signalhebelsperre (false, fs_kasten.bk[1], anz.sig[3]);
		kasten[8] = new Weichenhebelsperre ();
		kasten[9] = new Weichenhebelsperre ();
		
//		Hebel.LoadImages();
		hebel = new Hebel[10];
		hebel[0]  = new Weichenhebel (0, "ns_1", kasten[0]);
		Fahrstrasse.wh[0] = (Weichenhebel)hebel[0];
		hebel[1]  = new Weichenhebel (1, "ns_2Sp", kasten[1]);
		Fahrstrasse.wh[1] = (Weichenhebel)hebel[1];
		hebel[2]  = new Signalhebel (2, "ns_A", true, kasten[2], anz.sig[0]);
		Fahrstrasse.sh[0] = (Signalhebel)hebel[2];
		hebel[3]  = new Signalhebel (3, "ns_Ad", false, kasten[3], null);
		Fahrstrasse.sh[1] = (Signalhebel)hebel[3];
		hebel[4]  = new Signalhebel (4, "ns_B", false, kasten[4], anz.sig[1]);
		Fahrstrasse.sh[2] = (Signalhebel)hebel[4];
		hebel[5]  = new Signalhebel (5, "ns_C", false, kasten[5], anz.sig[2]);
		Fahrstrasse.sh[3] = (Signalhebel)hebel[5];
		hebel[6]  = new Signalhebel (6, "ns_Dd", false, kasten[6], null);
		Fahrstrasse.sh[4] = (Signalhebel)hebel[6];
		hebel[7]  = new Signalhebel (7, "ns_D", true, kasten[7], anz.sig[3]);
		Fahrstrasse.sh[5] = (Signalhebel)hebel[7];
		hebel[8]  = new Weichenhebel (8, "ns_34", kasten[8]);
		Fahrstrasse.wh[2] = (Weichenhebel)hebel[8];
		hebel[9]  = new Weichenhebel (9, "ns_5", kasten[9]);
		Fahrstrasse.wh[3] = (Weichenhebel)hebel[9];
		
		((DSigPseudosperre)(kasten[3])).setSignale (hebel[2], hebel[5]);
		((DSigPseudosperre)(kasten[6])).setSignale (hebel[7], hebel[4]);
		
		hebelkaesten.add (kasten[0]);
		hebelkaesten.add (kasten[1]);
		hebelkaesten.add (kasten[2]);
		hebelkaesten.add (kasten[3]);
		hebelkaesten.add (kasten[4]);
		hebelkaesten.add (kasten[5]);
		hebelkaesten.add (kasten[6]);
		hebelkaesten.add (kasten[7]);
		hebelkaesten.add (kasten[8]);
		hebelkaesten.add (kasten[9]);
		hebelbank.add (hebel[0]);
		hebelbank.add (hebel[1]);
		hebelbank.add (hebel[2]);
		hebelbank.add (hebel[3]);
		hebelbank.add (hebel[4]);
		hebelbank.add (hebel[5]);
		hebelbank.add (hebel[6]);
		hebelbank.add (hebel[7]);
		hebelbank.add (hebel[8]);
		hebelbank.add (hebel[9]);

		/*
		bktf1 = new BlockTestFrame (fs_kasten.bk[0], "Block Kesswil");
		bktf1.setVisible(true);
		bktf2 = new BlockTestFrame  (fs_kasten.bk[1], "Block Altnau");
		bktf2.setVisible(true);
		*/
		
		r = new SpurElement[25];
		
		r[0] = fs_kasten.bk[0];
		r[1] = new Gleis();
		r[2] = new FSWeiche(1);
		r[3] = new Gleis();
		r[4] = new Weiche(2);
		r[5] = new SpurElement();
		r[6] = new SpurElement();
		r[7] = new SpurElement();
		r[8] = new Weiche(4);
		r[9] = new SpurElement();
		r[10] = new Gleis();
		r[11] = new Gleis();
		r[12] = new FSWeiche(5);
		r[13] = new SpurElement();
		r[14] = fs_kasten.bk[1];
		r[15] = anz.sig[0];
		r[16] = new Signalhalt();
		r[17] = new Signalhalt();
		r[18] = new Signalhalt();
		r[19] = new Signalhalt();
		r[20] = new Signalhalt();
		r[21] = new Signalhalt();
		r[22] = anz.sig[3];
		r[23] = anz.sig[1];
		r[24] = anz.sig[2];
		
		((Block) r[0]).initRoute(null, r[15], 2000);
		((Gleis) r[1]).initRoute(anz.l[4], r[15], r[23], 50);
		((FSWeiche)r[2]).initRoute(anz.l[0], r[23], r[4], r[3], true, 50);
		((FSWeiche)r[2]).initSignale((Signalhebelsperre)kasten[2], (Signalhebelsperre)kasten[4]);
		((Gleis) r[3]).initRoute(anz.l[5], r[2], r[18], 50);
		((Weiche)r[4]).initRoute(anz.l[1], r[2], r[17], r[16], true, 50);
		r[5].initRoute (r[16], r[19], 250);
		r[6].initRoute (r[17], r[8], 250);
		r[7].initRoute (r[18], r[21], 450);
		((Weiche)r[8]).initRoute(anz.l[2], r[9], r[6], r[19], false, 50);
		r[9].initRoute (r[8], r[20], 150);
		((Gleis)r[10]).initRoute(anz.l[6], r[20], r[12], 50);
		((Gleis)r[11]).initRoute(anz.l[7], r[21], r[12], 50);
		((FSWeiche)r[12]).initRoute(anz.l[3], r[24], r[10], r[11], false, 50);
		((FSWeiche)r[12]).initSignale((Signalhebelsperre)kasten[7], (Signalhebelsperre)kasten[5]);
		r[13].initRoute (r[24], r[22], 50);
		((Block)r[14]).initRoute(r[22], null, 2000);
		
		
		((Signal)r[15]).initRoute(r[0], r[1], true);
		((Signalhalt)r[16]).initRoute(anz.sig[1], r[4], r[5], false);
		((Signalhalt)r[17]).initRoute(anz.sig[1], r[4], r[6], false);
		((Signalhalt)r[18]).initRoute(anz.sig[1], r[3], r[7], false);
		((Signalhalt)r[19]).initRoute(anz.sig[2], r[5], r[8], true);
		((Signalhalt)r[20]).initRoute(anz.sig[2], r[9], r[10], true);
		((Signalhalt)r[21]).initRoute(anz.sig[2], r[7], r[11], true);
		((Signal)r[22]).initRoute(r[13], r[14], false);
		
		((Signal)r[23]).initRoute(r[1], r[2], false);
		((Signal)r[24]).initRoute(r[12], r[13], true);
		
		((Weichenhebel)hebel[0]).setWeiche((Weiche)r[2]);
		((Weichenhebel)hebel[1]).setWeiche((Weiche)r[4]);
		((Weichenhebel)hebel[8]).setWeiche((Weiche)r[8]);
		((Weichenhebel)hebel[9]).setWeiche((Weiche)r[12]);
		
		anz.initBlock (fs_kasten.bk[0], fs_kasten.bk[1]);
	}
	
	public void repaintHebel (int id) {
		hebel[id].repaint();
	}
	
	public static Anzeige anz;	// Muss static public sein, wegen den Lampen...
	Hebelsperre kasten[];
	Hebel hebel[];
	Container hebelage;
	Container hebelbank;
	Container hebelkaesten;
	public static FSKasten fs_kasten;	// Dasselbe...
	
//	BlockTestFrame bktf1, bktf2;
	
	SpurElement r[];
	
	static final long serialVersionUID = 4336720779563234876L;
}
