/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

import java.awt.*;

class Weichenhebelsperre extends Hebelsperre implements Runnable {
	public Weichenhebelsperre () {
		super ();
		bild = wei_k;
	}

	public void umlegen() {
		lampe_ein = true;
		drawLampe (getGraphics());
		new Thread(this).start();
	}
	
	public void run() {
		try {
			Thread.sleep(1500);
		} catch (InterruptedException e) {
			System.out.println ("Interrupted Exception");
		}
		lampe_ein = false;
		drawLampe (getGraphics());
	}

	public void drawLampe (Graphics g) {
		if (lampe_ein) g.setColor (Color.YELLOW);
		else g.setColor (Color.DARK_GRAY);
		g.drawLine (28, 11, 31, 11);
		g.drawLine (27, 12, 32, 12);
		g.drawLine (26, 13, 33, 13);
		g.drawLine (26, 14, 33, 14);
		g.drawLine (26, 15, 33, 15);
		g.drawLine (26, 16, 33, 16);
		g.drawLine (27, 17, 32, 17);
		g.drawLine (28, 18, 31, 18);
	}

	public void paint (Graphics g) {
		if (bild == null) return;
		g.drawImage (bild, 0, 0, this);
		drawLampe (g);
	}

	boolean lampe_ein;
	
	static final long serialVersionUID = -8966470903386128119L;
}
